#ifndef _data_h
#define _data_h

// clubが使用するSPE数
#define NUM_OF_SPE_CLUB 1
// SPSAが使用するSPE数
#define NUM_OF_SPE_SPSA 3
// コマンド
#define COMMAND_NONE 0
#define COMMAND_WORK 1
#define COMMAND_QUIT 2
// ジョブがないときの待ち時間(マイクロ秒)
#define WAIT_USLEEP 100
// SUFのSPEもJOBを行う(行わない場合は0)
#define SUF_SPE_WORK 1


// パラメータ用データの共用体（4バイト）
typedef union
{
  int i;
  unsigned int ui;
  float f;
} mcl_cf_param_data_t;


// マンデルブロ集合用パラメーター
typedef struct
{
  unsigned int xres; // 画像の幅
  unsigned int yres; // 画像の高さ
  float cx; // 中心x座標
  float cy; // 中心y座標
  float zoom; // ズーム率
  unsigned int frame; // フレームNo.
  unsigned int max_count; // 最大ループ数
  float color_u; // 色u
  float color_v; // 色v
  unsigned int out_ea; // 出力パケットのea
  unsigned int para_my; // 自分のSPE番号
  unsigned int para_all; // JOBを行う全SPE数
  // 位置合わせ用ダミー
  unsigned int dummy[20];
} mandel_params_t;


// パラメーター情報の構造体
typedef struct
{
  unsigned int command; // コマンド
  unsigned int job_id; // ジョブID(1ずつインクリメント)
  unsigned int param_ea; // パラメーターのea
  // 位置合わせ用ダミー
  unsigned int dummy[29];
} param_info_t;


// Worker SPEから返される結果
typedef struct
{
  unsigned int job_id; // 処理を完了したジョブID
  // 位置合わせ用ダミー
  unsigned int dummy[31];
} worker_result_t;


#endif /* _data_h */
