#ifndef _job_h
#define _job_h

#include <stdio.h>
#include <spurs/spsa/spsa.h>
#include <spurs/club/suf.h>
#include <spu_mfcio.h>
#include <spu_intrinsics.h>
#include "data.h"

void mcl_load_and_wait(void * ls, unsigned int ea, unsigned int size);
void mcl_save_and_wait(void * ls, unsigned int ea, unsigned int size);
void mcl_usleep(unsigned int time);
void job(mandel_params_t * param);


// スタックに128バイトアラインの領域を確保
// 例：vector unsigned int* var = mcl_aligned_alloca(sizeof(vector unsigned int));
#define mcl_aligned_alloca( _mcl_aa_size_ ) ((void*)(((int)alloca((_mcl_aa_size_) + 128) + 127) & ~127))


// カウンターの差をintで返す
static inline int counter_minus(unsigned int a, unsigned int b)
{
  return ((int)a - (int)b);
}


// 2つのunsigned intのカウンターを比較
// 大きければ1、それ以外は0を返す
// 一方の値が0xffffffffからオーバーフローして0になった場合などでも判定可能。
// ただし2つの数値の差の絶対値が0x80000000以上の場合は反転する。
// タイマーなど双方の数値が永久にインクリメントされるような用途に使用。
static inline unsigned int counter_greater_than(unsigned int greater, unsigned int lesser)
{
  unsigned int bitnum = sizeof(unsigned int) * 8u - 1u;
  return (lesser - greater) >> bitnum;
}


// 大きいか、等しければ1、それ以外は0を返す
static inline unsigned int counter_greater_than_equal(unsigned int greater, unsigned int lesser)
{
  unsigned int bitnum = sizeof(unsigned int) * 8u - 1u;
  return (lesser - greater - 1u) >> bitnum;
}


#endif /* _job_h */
